import os
import time
from pyrogram import Client, filters
from pyrogram.errors import FloodWait

# اطلاعات مورد نیاز برای اجرای ربات
api_id = ""
api_hash = ""
bot_token = ""

# مسیر ذخیره فایل‌ها
FILE_STORAGE_PATH = "files/"
if not os.path.exists(FILE_STORAGE_PATH):
    os.makedirs(FILE_STORAGE_PATH)

# ایجاد کلاینت تلگرام
app = Client("my_bot", api_id=api_id, api_hash=api_hash, bot_token=bot_token)

# هندلر برای دریافت فایل
@app.on_message(filters.document | filters.video | filters.audio | filters.photo)
async def handle_file(client, message):
    sender = message.from_user.username if message.from_user.username else "user"
    
    # پیام خوش‌آمدگویی
    msg = await message.reply(f'Hello, {sender}! Your file is being processed...')

    # بررسی نوع فایل و تعیین نام آن
    if message.document:
        file_name = message.document.file_name
    elif message.video:
        file_name = message.video.file_name or 'unknown_video.mp4'
    elif message.audio:
        file_name = message.audio.file_name or 'unknown_audio.mp3'
    elif message.photo:
        file_name = 'photo.jpg'  # عکس‌ها معمولاً نام فایل ندارند و می‌توانید یک نام پیش‌فرض به آن‌ها اختصاص دهید.
    else:
        file_name = 'unknown_file'

    file_path = os.path.join(FILE_STORAGE_PATH, file_name)
    
    last_progress = -1
    last_update_time = time.time()
    last_byte = 0
    last_byte_time = last_update_time

    # تابع برای نمایش درصد دانلود شده، سرعت دانلود و زمان باقی‌مانده
    async def progress_callback(current, total):
        nonlocal last_progress, last_update_time, last_byte, last_byte_time
        progress = current * 100 // total
        current_time = time.time()
        bytes_downloaded = current - last_byte
        time_elapsed = current_time - last_byte_time
        speed = (bytes_downloaded / time_elapsed) / (1024 * 1024) if time_elapsed > 0 else 0  # MB/s
        last_byte = current
        last_byte_time = current_time
        
        if speed > 0:
            remaining_bytes = total - current
            estimated_time = (remaining_bytes / (speed * 1024 * 1024))  # in seconds
            remaining_time = time.strftime('%H:%M:%S', time.gmtime(estimated_time))
        else:
            remaining_time = 'Calculating...'

        if progress != last_progress and (current_time - last_update_time) > 5:
            last_progress = progress
            last_update_time = current_time
            try:
                speed_message = f'{speed:.2f} MB/s'
                await msg.edit(f'Downloading: {progress}% - Speed: {speed_message} - Time remaining: {remaining_time}')
            except FloodWait as e:
                print(f'Flood wait error: {e}')
                await asyncio.sleep(e.x)

    try:
        # دانلود فایل
        await message.download(file_path, progress=progress_callback)
        await msg.edit(f'File downloaded successfully and stored at {file_path}')
    except Exception as e:
        print(f'Error during download: {e}')
        await msg.edit('Failed to download the file.')

# اجرای ربات
app.run()
